import Cookies from 'js-cookie';
import { InfojobsVisitorUseCase } from './IdUseCase';
import { InfojobsVisitorIdCookieRepository } from './CookieRepository';
import { DomainTrimmer } from './DomainTrimmer';
import { AdobeMarketingCloudVisitorIdRepository } from './AdobeRepository';
import { v4 as uuid } from 'uuid';
export var infojobsVisitorIdFactory = function infojobsVisitorIdFactory(_ref) {
  var _ref$getCookie = _ref.getCookie,
    getCookie = _ref$getCookie === void 0 ? Cookies.get : _ref$getCookie,
    _ref$setCookie = _ref.setCookie,
    setCookie = _ref$setCookie === void 0 ? Cookies.set : _ref$setCookie,
    _ref$host = _ref.host,
    host = _ref$host === void 0 ? window.location.host : _ref$host;
  var domainTrimmer = new DomainTrimmer({
    host: host
  });
  var cookieRepository = new InfojobsVisitorIdCookieRepository({
    getCookie: getCookie,
    setCookie: setCookie,
    domainName: domainTrimmer.get()
  });
  var adobeRepository = new AdobeMarketingCloudVisitorIdRepository();
  return new InfojobsVisitorUseCase({
    cookieRepository: cookieRepository,
    adobeRepository: adobeRepository,
    uuidFactory: uuid
  });
};